#include "otabrowse5.h"
#pragma hdrstop

#include "resourceeditor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TResourceEditorForm *ResourceEditorForm;
//---------------------------------------------------------------------------
__fastcall TResourceEditorForm::TResourceEditorForm(TComponent* Owner)
        : TForm(Owner), pr(NULL)
{
}
void __fastcall TResourceEditorForm::FormShow(TObject *Sender)
{ bRefresh->Click();
  eCreateLang->Text="0x"+IntToHex((int)GetUserDefaultLangID(),8);
  //
  Caption=AnsiString("ResourceEditor - ")+ExtractFileName(pr->GetFileName());
  eFileName->Text=pr->GetFileName();
  eModified->Text=BoolToString(pr->GetModified());
}
//---------------------------------------------------------------------------
void __fastcall TResourceEditorForm::bRefreshClick(TObject *Sender)
{ lbEntries->Items->Clear();
  int num=pr->GetEntryCount();
  for (int i=0; i<num; i++)
  { _di_IOTAResourceEntry re=pr->GetEntry(i);
    AnsiString s="";
    s=s+ResourceNameToString(re->GetResourceName())+" - ";
    s=s+ResourceTypeToString(re->GetResourceType())+" @";
    s=s+"0x"+IntToHex((int)re->GetEntryHandle(),8);
    lbEntries->Items->Add(s);
  }
  lbEntries->ItemIndex=-1;
}
//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bDeleteEntryClick(TObject *Sender)
{ if (lbEntries->ItemIndex==-1) return;
  AnsiString s=lbEntries->Items->Strings[lbEntries->ItemIndex];
  int p=s.Pos("@"); s=s.SubString(p+1,s.Length()-p);
  int handle=s.ToInt();
  pr->DeleteEntry((void*)handle);
  bRefresh->Click();
}
//---------------------------------------------------------------------------
void __fastcall TResourceEditorForm::bFindEntryClick(TObject *Sender)
{ char *type=ResourceTypeFromString(cbFindEntry->Text);
  char *name=ResourceNameFromString(eFindEntryName->Text);
  if (type==NULL || name==NULL) {Application->MessageBox("Invalid find","Find entry",MB_OK);return;}
  _di_IOTAResourceEntry re=pr->FindEntry(type,name);
  if (re==NULL) {Application->MessageBox("Unable to find specified entry","Find Entry",MB_OK); return;}
  AnsiString shandle="0x"+IntToHex((int)re->GetEntryHandle(),8);
  int foundentry=-1;
  for (int i=0; i<lbEntries->Items->Count && foundentry==-1; i++)
  { if (lbEntries->Items->Strings[i].Pos(shandle)!=0) foundentry=i;
  }
  if (foundentry==-1) {Application->MessageBox("Internal error. Couldn't find entry in list","Find Entry",MB_OK);return;}
  lbEntries->ItemIndex=foundentry;
  bGetEntry->Click();
}
//---------------------------------------------------------------------------
void __fastcall TResourceEditorForm::bCreateEntryClick(TObject *Sender)
{ char *type=ResourceTypeFromString(cbCreateType->Text);
  char *name=ResourceNameFromString(eCreateName->Text.c_str());
  bool bad=false; if (type==NULL||name==NULL) bad=true;
  WORD flags,langid; int DataVersion,Version,Characteristics;
  try
  { flags=(WORD)eCreateFlags->Text.ToInt();
    langid=(WORD)eCreateLang->Text.ToInt();
    DataVersion=eCreateDataVersion->Text.ToInt();
    Version=eCreateVersion->Text.ToInt();
    Characteristics=eCreateCharacteristics->Text.ToInt();
  }
  catch (EConvertError &err) {bad=true;}
  if (bad) Application->MessageBox("Invalid create data","Create Entry",MB_OK);
  else
  { _di_IOTAResourceEntry re=pr->CreateEntry(type,name,flags,langid,DataVersion,Version,Characteristics);
    if (re==NULL) Application->MessageBox("Failed to create entry","Create Entry",MB_OK);
    else ShowResourceEntry(this,re);
  }
  bRefresh->Click();
}

//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bCreateIconClick(TObject *Sender)
{ cbCreateType->Text="RT_ICON";
  char *type=ResourceTypeFromString(cbCreateType->Text);
  char *name=ResourceNameFromString(eCreateName->Text.c_str());
  bool bad=false; if (type==NULL||name==NULL) bad=true;
  WORD flags,langid; int DataVersion,Version,Characteristics;
  try
  { flags=(WORD)eCreateFlags->Text.ToInt();
    langid=(WORD)eCreateLang->Text.ToInt();
    DataVersion=eCreateDataVersion->Text.ToInt();
    Version=eCreateVersion->Text.ToInt();
    Characteristics=eCreateCharacteristics->Text.ToInt();
  }
  catch (EConvertError &err) {bad=true;}
  if (bad) Application->MessageBox("Invalid create data","Create Entry",MB_OK);
  else
  { if (ExtractFileExt(CreateDialog1->FileName)!=".ico") CreateDialog1->FileName="";
    CreateDialog1->DefaultExt="ico";
    CreateDialog1->Filter="Icons (*.ico)|*.ico";
    bool res=CreateDialog1->Execute();
    if (res)
    { _di_IOTAResourceEntry re=AddIconFileResource(CreateDialog1->FileName,name,flags,langid,DataVersion,Version,Characteristics,pr);
      if (re==NULL) Application->MessageBox("Failed to create icon","Create Icon",MB_OK);
      else ShowResourceEntry(this,re);
    }
  }
  bRefresh->Click();
}
//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bCreateBitmapClick(TObject *Sender)
{ cbCreateType->Text="RT_BITMAP";
  char *type=ResourceTypeFromString(cbCreateType->Text);
  char *name=ResourceNameFromString(eCreateName->Text.c_str());
  bool bad=false; if (type==NULL||name==NULL) bad=true;
  WORD flags,langid; int DataVersion,Version,Characteristics;
  try
  { flags=(WORD)eCreateFlags->Text.ToInt();
    langid=(WORD)eCreateLang->Text.ToInt();
    DataVersion=eCreateDataVersion->Text.ToInt();
    Version=eCreateVersion->Text.ToInt();
    Characteristics=eCreateCharacteristics->Text.ToInt();
  }
  catch (EConvertError &err) {bad=true;}
  if (bad) Application->MessageBox("Invalid create data","Create Bitmap",MB_OK);
  else
  { if (ExtractFileExt(CreateDialog1->FileName)!=".bmp") CreateDialog1->FileName="";
    CreateDialog1->DefaultExt="bmp";
    CreateDialog1->Filter="Bitmaps (*.bmp)|*.bmp";
    bool res=CreateDialog1->Execute();
    if (res)
    { _di_IOTAResourceEntry re=AddBitmapFileResource(CreateDialog1->FileName,name,flags,langid,DataVersion,Version,Characteristics,pr);
      if (re==NULL) Application->MessageBox("Failed to create bitmap","Create Bitmap",MB_OK);
      else ShowResourceEntry(this,re);
    }
  }
  bRefresh->Click();
}


//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bGetEntryClick(TObject *Sender)
{ if (lbEntries->ItemIndex==-1) return;
  _di_IOTAResourceEntry re=pr->GetEntry(lbEntries->ItemIndex);
  if (re==NULL) Application->MessageBox("Failed to get entry","Get Entry",MB_OK);
  else ShowResourceEntry(this,re);
}
//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bDeleteIconGroupClick(TObject *Sender)
{ if (lbEntries->ItemIndex==-1) return;
  AnsiString s=lbEntries->Items->Strings[lbEntries->ItemIndex];
  int p=s.Pos("- RT_GROUP_ICON");
  if (p==0) {Application->MessageBox("That's not an icongroup!","Delete Icon Group",MB_OK);return;}
  s=s.SubString(1,p-2);
  bool res=DeleteIconGroup(ResourceNameFromString(s),pr);
  if (res) bRefresh->Click();
  else Application->MessageBox("Error deleting icon group","Delete Icon Group",MB_OK);
}
//---------------------------------------------------------------------------


void __fastcall TResourceEditorForm::lbEntriesDblClick(TObject *Sender)
{ bGetEntry->Click();
}
//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bMarkModifiedClick(TObject *Sender)
{ pr->MarkModified();
  eModified->Text=BoolToString(pr->GetModified());
}
//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bGetModuleClick(TObject *Sender)
{ _di_IOTAModule m = pr->GetModule();
  if (m==NULL) Application->MessageBox("Module not found","Get Module",MB_OK);
  else ShowModule(this,m);
}
//---------------------------------------------------------------------------

void __fastcall TResourceEditorForm::bShowClick(TObject *Sender)
{ pr->Show();
}
//---------------------------------------------------------------------------

